// tutor5Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "tutor5.h"
#include "tutor5Dlg.h"
#include "adodc.h"
#include "_recordset.h"
#include "field.h"
#include "fields.h"
#include "selbookmarks.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTutor5Dlg dialog

CTutor5Dlg::CTutor5Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTutor5Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTutor5Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTutor5Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTutor5Dlg)
	DDX_Control(pDX, IDC_ADODC1, m_adodc);
	DDX_Control(pDX, IDC_TDBGRID1, m_grid);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTutor5Dlg, CDialog)
	//{{AFX_MSG_MAP(CTutor5Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTutor5Dlg message handlers

BOOL CTutor5Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTutor5Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTutor5Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTutor5Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTutor5Dlg::OnButton1() 
{
	//This routine loops through the Recordset to find and
	//highlight all records with Country = "Germany"

	// Set the cursor to an hourglass and save the old cursor into
    // hOldCursor. We do this just in case we have a lot of records
    // to search through.
    HCURSOR hCursorHourglass = LoadCursor(NULL, IDC_WAIT);
    HCURSOR hOldCursor = SetCursor(hCursorHourglass);
	

	//We shall use a clone so that we do not move the actual
	//record position of the Data control
	C_Recordset adodcClone = m_adodc.GetRecordset().Clone(1L); //open the clone as read only

	adodcClone.MoveFirst();					//move to the first record

	// Create an object to refer to the "Country" field of the
    // recordset
	CField CountryFld = adodcClone.GetFields().GetItem(COleVariant(2L));

    // Bmks will hold all of the bookmarks of the rows we want to
    // mark. This is an array and will grow as we add bookmarks to
    // it. Since we will be resizing it anyway, just allocate space
    // for one bookmark.

    VARIANT *Bmks = (VARIANT *) malloc(sizeof(VARIANT));

	// Count of bookmarks held in our dynamic array
    long lCount = 0;

    // Now loop through the clone, seeing which rows need to be
    // selected (marked).  We stop when we hit EOF.

	while(!adodcClone.GetEof())
	{
        // Read the contents of the "Country" field for this record
        CString cs = V_BSTR(&CountryFld.GetValue());
        if(cs == _T("Germany"))
        {
            // If the Country field for this record = "Germany"
            // grow the bookmark array by one and store the
            // bookmark of this row.
            Bmks = (VARIANT *) realloc(Bmks, ++lCount * sizeof(VARIANT));
            Bmks[lCount-1] = adodcClone.GetBookmark();
        }

        adodcClone.MoveNext();
    }

	//create a SelBookmarks variable
	//CSelBookmarks selBks;
	//selBks.AttachDispatch(m_grid.GetSelBookmarks());

	//Add all of the bookmarks in our Bmks array to the grid's 
	//SelBookmarks collection to select (mark) them.

    for(long i=0; i<lCount; i++)
        //m_Grid.SelBookmarks().Add(Bmks[i]);
		m_grid.GetSelBookmarks().Add(Bmks[i]);

    // Finally, since we dynamically allocated the space for Bmks,
    // we have to free the memory it used.
    free(Bmks);

    // Restore the cursor to what it was before we changed it to an
    // hourglass
    SetCursor(hOldCursor);




	
}

void CTutor5Dlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	m_grid.GetSelBookmarks().Clear();
	
}
